#include "CHorde3D.h"
#include "Horde3D.h"

#ifdef __cplusplus
extern "C" {
#endif

	// Basic
extern const char *Horde3D_getVersionString()
{
	return(Horde3D::getVersionString());
}

extern int Horde3D_init()
{
	return(Horde3D::init());
}

extern void Horde3D_release()
{
	Horde3D::release();
}

extern void Horde3D_resize( int x, int y, int width, int height )
{
	Horde3D::resize(x, y, width, height);
}

extern void Horde3D_render()
{
	Horde3D::render();
}

extern void Horde3D_clear()
{
	Horde3D::clear();
}

	// Pipeline
extern int Horde3D_loadPipelineConfig( const char *configFilename )
{
	return(Horde3D::loadPipelineConfig(configFilename));
}

	// Messages
extern const char *Horde3D_getMessage( unsigned int *level, float *time )
{
	return(Horde3D::getMessage(level, time));
}

	// Active Camera
extern Horde3D_NodeHandle Horde3D_getActiveCamera()
{
	return(Horde3D::getActiveCamera());
}

extern int Horde3D_setActiveCamera( Horde3D_NodeHandle cameraNode )
{
	return(Horde3D::setActiveCamera(cameraNode));
}

	// Options
extern float Horde3D_getOption(Horde3D_EngineOptions param)
{
	return(Horde3D::getOption((EngineOptions::List) param));
}

extern int Horde3D_setOption(Horde3D_EngineOptions param, float value)
{
	return(Horde3D::setOption((EngineOptions::List) param, value));
}

	// Overlay
extern void Horde3D_showOverlay( float x_ll, float y_ll, float u_ll, float v_ll,
						  float x_lr, float y_lr, float u_lr, float v_lr,
						  float x_ur, float y_ur, float u_ur, float v_ur,
						  float x_ul, float y_ul, float u_ul, float v_ul,
						  unsigned int layer, Horde3D_ResHandle materialRes )
{
	Horde3D::showOverlay(x_ll, y_ll, u_ll, v_ll,
						  x_lr, y_lr, u_lr, v_lr,
						  x_ur, y_ur, u_ur, v_ur,
						  x_ul, y_ul, u_ul, v_ul,
						  layer, materialRes);
}

	// Render Target
extern int Horde3D_getRenderTargetData( const char *targetName, unsigned int bufIndex,
						  unsigned int *width, unsigned int *height, unsigned int *compCount,
						  float *dataBuffer, unsigned int bufferSize )
{
	return(Horde3D::getRenderTargetData(targetName, bufIndex,
						  width, height, compCount,
						  dataBuffer, bufferSize));
}

	// Resources
extern Horde3D_ResourceTypes Horde3D_getResourceType( Horde3D_ResHandle res )
{
	return((Horde3D_ResourceTypes) Horde3D::getResourceType(res));
}

extern Horde3D_ResHandle Horde3D_findResource( Horde3D_ResourceTypes type, const char *name )
{
	return(Horde3D::findResource((ResourceTypes::List) type, name));
}

extern Horde3D_ResHandle Horde3D_addResource( Horde3D_ResourceTypes type, const char *name, unsigned int flags )
{
	return(Horde3D::addResource((ResourceTypes::List) type, name, flags));
}

extern int Horde3D_removeResource( Horde3D_ResHandle res )
{
	return(Horde3D::removeResource(res));
}

extern int Horde3D_loadResource( const char *name, const char *data, unsigned int size )
{
	return(Horde3D::loadResource(name, data, size));
}

extern int Horde3D_unloadResource( Horde3D_ResHandle res )
{
	return(Horde3D::unloadResource(res));
}

extern const void *Horde3D_getResourceData( Horde3D_ResHandle res, Horde3D_ResourceData param )
{
	return(Horde3D::getResourceData(res, (ResourceData::List) param));
}

extern int Horde3D_updateResourceData( Horde3D_ResHandle res, Horde3D_ResourceData param, const void *data, unsigned int size )
{
	return(Horde3D::updateResourceData(res, (ResourceData::List) param, data, size));
}

extern const char *Horde3D_queryUnloadedResource()
{
	return(Horde3D::queryUnloadedResource());
}

extern const char *Horde3D_getResourcePath( Horde3D_ResourceTypes type )
{
	return(Horde3D::getResourcePath((ResourceTypes::List) type));
}

extern void Horde3D_setResourcePath( Horde3D_ResourceTypes type, const char *path )
{
	Horde3D::setResourcePath((ResourceTypes::List) type, path);
}

extern void Horde3D_releaseUnusedResources()
{
	Horde3D::releaseUnusedResources();
}

extern int Horde3D_setMaterialUniform( Horde3D_ResHandle materialRes, const char *name, float a, float b, float c, float d )
{
	return(Horde3D::setMaterialUniform(materialRes, name, a, b, c, d));
}

	// Nodes
extern Horde3D_SceneNodeTypes Horde3D_getNodeType( Horde3D_NodeHandle node )
{
	return((Horde3D_SceneNodeTypes) Horde3D::getNodeType(node));
}

extern const char *Horde3D_getNodeName( Horde3D_NodeHandle node )
{
	return(Horde3D::getNodeName(node));
}

extern int Horde3D_setNodeName( Horde3D_NodeHandle node, const char *name )
{
	return(Horde3D::setNodeName(node, name));
}

extern Horde3D_NodeHandle Horde3D_getNodeParent( Horde3D_NodeHandle node )
{
	return(Horde3D::getNodeParent(node));
}

extern Horde3D_NodeHandle Horde3D_getNodeChild( Horde3D_NodeHandle node, unsigned int index )
{
	return(Horde3D::getNodeChild(node, index));
}

extern Horde3D_NodeHandle Horde3D_addNodes( Horde3D_NodeHandle parent, Horde3D_ResHandle sceneGraphRes )
{
	return(Horde3D::addNodes(parent, sceneGraphRes));
}

extern int Horde3D_removeNode( Horde3D_NodeHandle node )
{
	return(Horde3D::removeNode(node));
}

extern int Horde3D_setNodeActivation( Horde3D_NodeHandle node, int active )
{
	return(Horde3D::setNodeActivation(node, active));
}

extern int Horde3D_getNodeTransform( Horde3D_NodeHandle node, float *px, float *py, float *pz,
							   float *rx, float *ry, float *rz, float *sx, float *sy, float *sz )
{
	return(Horde3D::getNodeTransform(node, px, py, pz,
						rx, ry, rz, sx, sy, sz));
}

extern int Horde3D_setNodeTransform( Horde3D_NodeHandle node, float px, float py, float pz,
							   float rx, float ry, float rz, float sx, float sy, float sz )
{
	return(Horde3D::setNodeTransform(node, px, py, pz,
						rx, ry, rz, sx, sy, sz));
}

extern int Horde3D_getNodeTransformMatrices( Horde3D_NodeHandle node, const float **relMat, const float **absMat )
{
	return(Horde3D::getNodeTransformMatrices(node, relMat, absMat));
}

extern int Horde3D_setNodeTransformMatrix( Horde3D_NodeHandle node, const float *mat4x4 )
{
	return(Horde3D::setNodeTransformMatrix(node, mat4x4));
}

extern int Horde3D_getNodeAABB( Horde3D_NodeHandle node, float *minX, float *minY, float *minZ,
						  float *maxX, float *maxY, float *maxZ )
{
	return(Horde3D::getNodeAABB(node, minX, minY, minZ,
						maxX, maxY, maxZ));
}

extern unsigned int Horde3D_findNodes( Horde3D_NodeHandle startNode, const char *name, Horde3D_SceneNodeTypes type )
{
	return(Horde3D::findNodes(startNode, name, (SceneNodeTypes::List) type));
}

extern Horde3D_NodeHandle Horde3D_getNodeFindResult( unsigned int index )
{
	return(Horde3D::getNodeFindResult(index));
}

extern Horde3D_NodeHandle Horde3D_castRay( Horde3D_NodeHandle node, float ox, float oy, float oz, float dx, float dy, float dz )
{
	return(Horde3D::castRay(node, ox, oy, oz, dx, dy, dz));
}

	// Group Node
extern Horde3D_NodeHandle Horde3D_addGroupNode( Horde3D_NodeHandle parent, const char *name )
{
	return(Horde3D::addGroupNode(parent, name));
}

extern float Horde3D_getGroupParam( Horde3D_NodeHandle node, Horde3D_GroupNodeParams param )
{
	return(Horde3D::getGroupParam(node, (GroupNodeParams::List) param));
}

extern int Horde3D_setGroupParam( Horde3D_NodeHandle node, Horde3D_GroupNodeParams param, float value )
{
	return(Horde3D::setGroupParam(node, (GroupNodeParams::List) param, value));
}

	// Model Node
extern Horde3D_NodeHandle Horde3D_addModelNode( Horde3D_NodeHandle parent, const char *name, Horde3D_ResHandle geometryRes )
{
	return(Horde3D::addModelNode(parent, name, geometryRes));
}

extern int Horde3D_setupModelAnimStage( Horde3D_NodeHandle node, unsigned int stage, Horde3D_ResHandle animationRes,
								  const char *startNode, int additive )
{
	return(Horde3D::setupModelAnimStage(node, stage, animationRes, startNode, additive));
}

extern int Horde3D_setModelAnimParams( Horde3D_NodeHandle node, unsigned int stage, float time, float weight )
{
	return(Horde3D::setModelAnimParams(node, stage, time, weight));
}

extern int Horde3D_setModelMorpher( Horde3D_NodeHandle node, const char *target, float weight )
{
	return(Horde3D::setModelMorpher(node, target, weight));
}

	// Mesh Node
extern Horde3D_NodeHandle Horde3D_addMeshNode( Horde3D_NodeHandle parent, const char *name, Horde3D_ResHandle materialRes, 
								unsigned int batchStart, unsigned int batchCount,
								unsigned int vertRStart, unsigned int vertREnd )
{
	return(Horde3D::addMeshNode(parent, name, materialRes,
					batchStart, batchCount,
					vertRStart, vertREnd));
}

extern float Horde3D_getMeshParam( Horde3D_NodeHandle node, Horde3D_MeshNodeParams param )
{
	return(Horde3D::getMeshParam(node, (MeshNodeParams::List) param));
}

extern int Horde3D_setMeshParam( Horde3D_NodeHandle node, Horde3D_MeshNodeParams param, float value )
{
	return(Horde3D::setMeshParam(node, (MeshNodeParams::List) param, value));
}

extern int Horde3D_getMeshData( Horde3D_NodeHandle node, unsigned int *vertPosArrayCount, const float **vertPosArrayData,
					  unsigned int *indexArrayCount, const unsigned int **indexArayData, unsigned int *indexOffset )
{
	return(Horde3D::getMeshData(node, vertPosArrayCount, vertPosArrayData,
					indexArrayCount, indexArayData, indexOffset));
}

extern int Horde3D_setMeshUniform( Horde3D_NodeHandle node, const char *name, float a, float b, float c, float d, int recursive )
{
	return(Horde3D::setMeshUniform(node, name, a, b, c, d, recursive));
}

	// Joint Node
extern Horde3D_NodeHandle Horde3D_addJointNode( Horde3D_NodeHandle parent, const char *name, unsigned int jointIndex )
{
	return(Horde3D::addJointNode(parent, name, jointIndex));
}

	// Light Node
extern Horde3D_NodeHandle Horde3D_addLightNode( Horde3D_NodeHandle parent, const char *name, Horde3D_ResHandle materialRes,
								 const char *lightingContext, const char *shadowContext )
{
	return(Horde3D::addLightNode(parent, name, materialRes,
					lightingContext, shadowContext));
}

extern float Horde3D_getLightParam( Horde3D_NodeHandle node, Horde3D_LightNodeParams param )
{
	return(Horde3D::getLightParam(node, (LightNodeParams::List) param));
}

extern int Horde3D_setLightParam( Horde3D_NodeHandle node, Horde3D_LightNodeParams param, float value )
{
	return(Horde3D::setLightParam(node, (LightNodeParams::List) param, value));
}

extern int Horde3D_setLightContexts( Horde3D_NodeHandle node, const char *lightingContext, const char *shadowContext )
{
	return(Horde3D::setLightContexts(node, lightingContext, shadowContext));
}

	// Camera Node
extern Horde3D_NodeHandle Horde3D_addCameraNode( Horde3D_NodeHandle parent, const char *name )
{
	return(Horde3D::addCameraNode(parent, name));
}

extern float Horde3D_getCameraParam( Horde3D_NodeHandle node, Horde3D_CameraNodeParams param )
{
	return(Horde3D::getCameraParam(node, (CameraNodeParams::List) param));
}

extern int Horde3D_setCameraParam( Horde3D_NodeHandle node, Horde3D_CameraNodeParams param, float value )
{
	return(Horde3D::setCameraParam(node, (CameraNodeParams::List) param, value));
}

extern int Horde3D_setupCameraView( Horde3D_NodeHandle node, float fov, float aspect, float nearDist, float farDist )
{
	return(Horde3D::setupCameraView(node, fov, aspect, nearDist, farDist));
}

extern int Horde3D_calcCameraProjectionMatrix( Horde3D_NodeHandle node, float *projMat )
{
	return(Horde3D::calcCameraProjectionMatrix(node, projMat));
}

	// Emitter Node
extern Horde3D_NodeHandle Horde3D_addEmitterNode( Horde3D_NodeHandle parent, const char *name,
								   Horde3D_ResHandle materialRes, Horde3D_ResHandle effectRes,
								   unsigned int maxParticleCount, int respawnCount )
{
	return(Horde3D::addEmitterNode(parent, name,
					materialRes, effectRes,
					maxParticleCount, respawnCount));
}

extern float Horde3D_getEmitterParam( Horde3D_NodeHandle node, Horde3D_EmitterNodeParams param )
{
	return(Horde3D::getEmitterParam(node, (EmitterNodeParams::List) param));
}

extern int Horde3D_setEmitterParam( Horde3D_NodeHandle node, Horde3D_EmitterNodeParams param, float value )
{
	return(Horde3D::setEmitterParam(node, (EmitterNodeParams::List) param, value));
}

extern int Horde3D_advanceEmitterTime( Horde3D_NodeHandle node, float timeDelta )
{
	return(Horde3D::advanceEmitterTime(node, timeDelta));
}

#ifdef __cplusplus
}
#endif
